#!/bin/sh

# Print in descending order of client last access time all clients that have
# a MapState flag of zero. The owners of these clients should run:
#
#   p4 sync #have  (beware of opened files)
#   p4 fstat //depot/foo  (can be //depot/foo, even if it doesn't exist)

# Point to awk that understands strftime() and sort that understands -n -r.

awk=awk
egrep=egrep
p4=p4
sort=sort

# Print the clients.

$p4 -Ztag clients | $egrep '^\.\.\. client |^\.\.\. Access |^\.\.\. Owner |^\.\.\. MapState ' | $awk '{ client = $3; getline; access = $3; getline; owner = $3; getline; printf "%s %s %s %s\n", access, owner, client, $0 }' | $egrep "... MapState 0" | $sort -n -r - | $awk '{ printf "%s %s\n", strftime( "%Y/%m/%d %H:%M:%S", $1 ), $0 }'
